import * as frontend from 'llparse-frontend';
import { Compilation, IRDeclaration, IRSignature } from '../compilation';
export declare abstract class Code<T extends frontend.code.Code> {
    readonly ref: T;
    protected cachedDecl: IRDeclaration | undefined;
    constructor(ref: T);
    abstract build(ctx: Compilation): IRDeclaration;
    protected getSignature(ctx: Compilation): IRSignature;
    protected getParams(): ReadonlyArray<string>;
    protected setAttributes(decl: IRDeclaration): void;
}
