"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const constants_1 = require("../constants");
const base_1 = require("./base");
class External extends base_1.Code {
    build(ctx) {
        if (this.cachedDecl !== undefined) {
            return this.cachedDecl;
        }
        const sig = this.getSignature(ctx);
        const decl = ctx.declareFunction(sig, this.ref.name);
        this.setAttributes(decl);
        this.cachedDecl = decl;
        return decl;
    }
    setAttributes(decl) {
        super.setAttributes(decl);
        decl.attrs.add(constants_1.FN_ATTR_CODE_EXTERNAL);
    }
}
exports.External = External;
//# sourceMappingURL=external.js.map