"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const frontend = require("llparse-frontend");
const base_1 = require("./base");
class Single extends base_1.Node {
    doBuild(bb, pos) {
        bb = this.prologue(bb, pos);
        const ctx = this.compilation;
        // Load the character
        let current = bb.load(pos.current);
        // Transform the character
        current = this.applyTransform(this.ref.transform, bb, current);
        // Mark error branches as unlikely
        const cases = this.ref.edges.map((edge) => {
            if (edge.node.ref instanceof frontend.node.Error) {
                return 'unlikely';
            }
            else {
                return 'likely';
            }
        });
        const weight = {
            cases,
            otherwise: this.ref.otherwise.node instanceof frontend.node.Error ?
                'unlikely' : 'likely',
        };
        const keys = this.ref.edges.map((edge) => edge.key);
        const s = ctx.switch(bb, current, keys, weight);
        s.cases.forEach((caseBB, i) => {
            const edge = this.ref.edges[i];
            this.tailTo(caseBB, edge, pos);
        });
        this.tailTo(s.otherwise, this.ref.otherwise, pos);
    }
}
exports.Single = Single;
//# sourceMappingURL=single.js.map