"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const base_1 = require("./base");
class SpanStart extends base_1.Node {
    doBuild(bb, pos) {
        // Prevent spurious empty spans
        bb = this.prologue(bb, pos);
        const ctx = this.compilation;
        const field = this.ref.field;
        bb.store(ctx.posArg(bb), ctx.spanPosField(bb, field.index));
        if (field.callbacks.length > 1) {
            const callback = ctx.unwrapCode(this.ref.callback);
            bb.store(callback.build(ctx), ctx.spanCbField(bb, field.index));
        }
        this.tailTo(bb, this.ref.otherwise, pos);
    }
}
exports.SpanStart = SpanStart;
//# sourceMappingURL=span-start.js.map