"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const base_1 = require("./base");
class External extends base_1.Code {
    buildGlobal(ctx, out) {
        ctx.importCode(this.ref.name, out);
    }
    // NOTE: Overridden in Span
    getArgs(ctx) {
        const args = [ctx.bufArg(), ctx.offArg()];
        if (this.ref.signature === 'value') {
            args.push(ctx.matchVar());
        }
        return args;
    }
    build(ctx, out) {
        const args = this.getArgs(ctx);
        out.push(`_${this.ref.name}(${args.join(', ')}) {`);
        out.push(`  return ${this.ref.name}(this, ${args.join(', ')});`);
        out.push(`}`);
    }
}
exports.External = External;
//# sourceMappingURL=external.js.map