"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const constants_1 = require("../constants");
const base_1 = require("./base");
class Sequence extends base_1.Node {
    doBuild(out) {
        const ctx = this.compilation;
        this.prologue(out);
        const matchSequence = ctx.getMatchSequence(this.ref.transform, this.ref.select);
        out.push(`${ctx.offArg()} = ${matchSequence}(${ctx.bufArg()}, ` +
            `${ctx.offArg()}, ${ctx.blob(this.ref.select)});`);
        let tmp;
        out.push(`const status = ${ctx.statusField()};`);
        out.push(`if (status === ${constants_1.SEQUENCE_COMPLETE}) {`);
        tmp = [];
        this.tailTo(tmp, {
            noAdvance: false,
            node: this.ref.edge.node,
            value: this.ref.edge.value,
        });
        ctx.indent(out, tmp, '  ');
        out.push(`} else if (status === ${constants_1.SEQUENCE_PAUSE}) {`);
        tmp = [];
        this.pause(tmp);
        ctx.indent(out, tmp, '  ');
        out.push('} else {');
        tmp = [];
        this.tailTo(tmp, this.ref.otherwise);
        ctx.indent(out, tmp, '  ');
        out.push('}');
    }
}
exports.Sequence = Sequence;
//# sourceMappingURL=sequence.js.map