"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const base_1 = require("./base");
class Single extends base_1.Node {
    doBuild(out) {
        const ctx = this.compilation;
        const otherwise = this.ref.otherwise;
        this.prologue(out);
        const transform = ctx.unwrapTransform(this.ref.transform);
        const current = transform.build(ctx, `${ctx.bufArg()}[${ctx.offArg()}]`);
        out.push(`switch (${current} | 0) {`);
        this.ref.edges.forEach((edge) => {
            let ch = edge.key.toString();
            // Non-printable ASCII, or single-quote
            if (!(edge.key < 0x20 || edge.key > 0x7e || edge.key === 0x27)) {
                ch = `/* '${String.fromCharCode(edge.key)}' */ ` + ch;
            }
            out.push(`  case ${ch}: {`);
            const tmp = [];
            this.tailTo(tmp, edge);
            ctx.indent(out, tmp, '    ');
            out.push('  }');
        });
        out.push(`  default: {`);
        const tmp = [];
        this.tailTo(tmp, otherwise);
        ctx.indent(out, tmp, '    ');
        out.push('  }');
        out.push(`}`);
    }
}
exports.Single = Single;
//# sourceMappingURL=single.js.map